# CBpanel "PAGER" plugin

name = "Pager"
description = "Draw a pager on the panel"

import CBpanel, gtk, gtk.gdk, wnck

class Plugin(CBpanel.Plugin):
    def __init__(self, panel, settings):
        CBpanel.Plugin.__init__(self, panel, settings)
        self.set_border_width(0)

        self.screen = wnck.screen_get_default()
        self.screen.force_update()

        ### TODO : add/remove label when ..
        #~ self.screen.connect("workspace-created", lambda s,w: self.resize())
        #~ self.screen.connect("workspace-destroyed", lambda s,w: self.resize())

        self.screen.connect("active-workspace-changed", lambda s,w: self.resize())

        workspace_count = self.screen.get_workspace_count()
        self.pager_label = []
        active_workspace = self.screen.get_active_workspace()
        active_workspace = active_workspace.get_number()

        for ind in range(workspace_count):
            btn = gtk.Button()
            btn.set_relief(gtk.RELIEF_NONE)
            btn.set_border_width(0)
            btn.set_focus_on_click(False)
            btn.set_property('can-focus', False)
            btn.connect("button-release-event", self.btn_released, ind)
            btn.show()

            label = gtk.Label()
            label.set_alignment(0.5, 0.5)
            self.panel.update_font(self, label)
            label.show()

            self.add(btn)

            box = gtk.VBox(False, 0)
            box.show()

            btn.add(box)
            box.add(label)
            self.pager_label.append(label)

        #~ self.add(self.pager)
        self.resize()
        self.show_all()

    def resize(self):
        workspace_count = self.screen.get_workspace_count()
        active_workspace = self.screen.get_active_workspace()
        active_workspace = active_workspace.get_number()

        for ind in range(workspace_count):
            if ind == active_workspace:
                tmp = "bold"
            else:
                tmp = "normal"
            self.pager_label[ind].set_markup("<span weight=\"%s\">%s</span>" % (tmp,ind+1))

    def btn_released(self, widget, event, ws_ind):
        new = self.screen.get_workspace(ws_ind)
        new.activate(event.time)

